# $Id: larrd.spec 323 2005-12-12 06:17:57Z rpmbuild $

%define bbver 19c
%define BBHOME %([ $BBHOME ] && echo $BBHOME || echo "/opt/bb" )
%define BBUSER %([ $BBUSER ] && echo $BBUSER || echo "bb" )
%define CGIBIN %([ $CGIBIN ] && echo $CGIBIN || echo "/var/www/cgi-bin" )
%define WEBROOT %([ $WEBROOT ] && echo $WEBROOT || echo "/var/www/html" )
%define HTTPUSER %([ $HTTPUSER ] && echo $HTTPUSER || echo "apache" )
%define LARRDHOME %([ $LARRDHOME ] && echo $LARRDHOME || echo "/opt/larrd" )


Summary: In a nutshell, larrd is about charts and graphs
Name: bigbrother-larrd
Version: 0.43c
Release: %RErelease 4
Epoch: 0
License: ?
Group: System Environment/Daemons
URL: http://larrd.packetpushers.net/
Source0: larrd-%{version}.tar.gz
Source1: larrd.logrotate
Source2: larrd-graphs-1.4.tar.gz
Patch0: larrd-vmstat.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Prefix: %{_prefix}
Requires: bash, grep, sed, gawk
Requires: coreutils, procps, findutils, sysstat, net-tools
Requires: bigbrother
BuildRequires: procps
BuildArch: noarch

%description
In a nutshell, larrd is about charts and graphs.
Specifically, larrd is a trending and capacity planning tool
for use with Big Brother.  larrd uses RRDTool as the backend.

%package server
Summary: In a nutshell, larrd is about charts and graphs.
Group: System Environment/Daemons
Requires: bigbrother-larrd bigbrother-server perl rrdtool patch
Provides: perl(larrd-config.pl)

%description server
In a nutshell, larrd is about charts and graphs.
Specifically, larrd is a trending and capacity planning tool
for use with Big Brother.  larrd uses RRDTool as the backend.

%prep
%setup -q -n larrd-%{version}
%setup -q -n larrd-%{version} -T -D -a 2
PROCPSVER=`rpm --queryformat='%{VERSION}\n' -q procps`
PROCPSVER=`echo $PROCPSVER | %{__awk} -F. '{print $1}'`
if [ $PROCPSVER -gt 2 ]; then
%patch0
fi

%build
 
%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT

%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d \
             ${RPM_BUILD_ROOT}%{BBHOME}/ext/bf \
             ${RPM_BUILD_ROOT}%{LARRDHOME} \
             ${RPM_BUILD_ROOT}/usr/local \
             ${RPM_BUILD_ROOT}%{_localstatedir}/www/cgi-bin
%{__ln_s} %{LARRDHOME} ${RPM_BUILD_ROOT}/usr/local/larrd
%{__ln_s} %{LARRDHOME} ${RPM_BUILD_ROOT}%{BBHOME}/ext/larrd
%{__cp} -p bf/* ${RPM_BUILD_ROOT}%{BBHOME}/ext/bf
%{__sed} -e 's:LARRDCOMM=STATUS:LARRDCOMM=DATA:' \
         -e 's:/usr/local/larrd:%{BBHOME}/ext:' bf-larrd.sh > \
         ${RPM_BUILD_ROOT}%{BBHOME}/ext/bf-larrd.sh
touch -r bf-larrd.sh ${RPM_BUILD_ROOT}%{BBHOME}/ext/bf-larrd.sh
%{__chmod} 0755 ${RPM_BUILD_ROOT}%{BBHOME}/ext/bf-larrd.sh

#%{__perl} install --bbhome %{BBHOME} --larrdhome %{LARRDHOME} --bbcgi=%{CGIBIN}
for FILE in apache-larrd.pl bbnet-larrd.pl bind-larrd.pl disk-larrd.pl \
            imap2-larrd.pl iostat-larrd.pl la-larrd.pl larrd-config.pl \
            larrd-html.pl larrd.pl larrd_scan.pl mailq-larrd.pl \
            netstat-larrd.pl nmailq-larrd.pl sendmail-larrd.pl socks-larrd.pl \
            temperature-larrd.pl template-larrd.pl vmstat-larrd.pl
do
  if [ $FILE = larrd-config.pl ]; then
    %{__sed} -e 's:/usr/local/rrdtool:/usr:' \
             -e 's:/usr/local/larrd:%{LARRDHOME}:' \
             -e 's:/usr/local/bbvar:%{_localstatedir}/opt/bbvar:' \
             -e 's:"netstat",:"apache","bind","iostat","netstat","sendmail","memory","nmailq","socks","imap2",:' \
             -e 's:/usr/local/apache2/htdocs/bb/bin/bb-hostsvc.sh:%{CGIBIN}/bb-hostsvc.sh:' \
             -e "s:\$ENV{'BBHOME'}/LARRDOUT:\$ENV{'BBVAR'}/LARRDOUT:" \
             -e "s:ENV{'LARRDHOME'}/tmp:ENV{'BBHOME'}/tmp:" $FILE > \
      ${RPM_BUILD_ROOT}%{LARRDHOME}/$FILE
  else
    %{__sed} 's:/usr/local/bin/perl:%{__perl}:' $FILE > \
      ${RPM_BUILD_ROOT}%{LARRDHOME}/$FILE
  fi
  touch -r $FILE ${RPM_BUILD_ROOT}%{LARRDHOME}/$FILE
  %{__chmod} 0755 ${RPM_BUILD_ROOT}%{LARRDHOME}/$FILE
done

cd cgi
for FILE in larrd-grapher.cgi monlaa.cgi larrd-graphs.cgi
do
  %{__sed} -e 's:/usr/local/bin/perl:%{__perl}:' \
           -e 's:qq{/usr/local/rrdtool/lib/perl}:qq{$ENV{'RRDPM'}}:' \
           -e 's:qq{/usr/local/larrd}:qq{%{LARRDHOME}}:' \
           -e 's:/usr/local/rrdtool/bin/rrdtool:/usr/bin/rrdtool:' \
           -e 's:/usr/local/bbvar/rrd:%{_localstatedir}/opt/bbvar/rrd:' \
    $FILE > ${RPM_BUILD_ROOT}%{_localstatedir}/www/cgi-bin/$FILE
  touch -r $FILE ${RPM_BUILD_ROOT}%{_localstatedir}/www/cgi-bin/$FILE
  %{__chmod} 0755 ${RPM_BUILD_ROOT}%{_localstatedir}/www/cgi-bin/$FILE
done
cd ..
%{__sed} -e 's:/usr/local/bin/perl:%{__perl}:' \
         -e 's:/usr/local/bb/larrd:%{LARRDHOME}:' \
         -e 's:/usr/local/bb/bb:%{BBHOME}:' larrd-graphs-1.4/larrd-graphs.cgi \
  > ${RPM_BUILD_ROOT}%{_localstatedir}/www/cgi-bin/larrd-graphs.cgi
touch -r larrd-graphs-1.4/larrd-graphs.cgi \
  ${RPM_BUILD_ROOT}%{_localstatedir}/www/cgi-bin/larrd-graphs.cgi

%{__sed} 's:&BBOUT:%{_localstatedir}/opt/bbvar/LARRDOUT:' %{SOURCE1} \
  > ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/bigbrother-larrd
%{__chmod} -x nmailq.readme.txt

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT
 
%post server
cd %{BBHOME}/www/help/
#%{__cp} -p bb-rep.html.DIST bb-rep.html.DIST-orig
%{__patch} bb-rep.html /usr/share/doc/%{name}-server-%{version}/bb-rep.html.patch

%preun server
cd %{BBHOME}/www/help/
#%{__patch} -R < /usr/share/doc/%{name}-%{version}/bb-rep.html.patch
%{__patch} -R bb-rep.html /usr/share/doc/%{name}-server-%{version}/bb-rep.html.patch

%files
%defattr(-,root,root)
%doc CHANGES FAQ INSTALL.clients README TODO nmailq.readme.txt
%{BBHOME}/ext/bf/
%config %{BBHOME}/ext/bf-larrd.sh

%files server
%defattr(-,root,root)
%doc INSTALL utils/ unsupported/ contrib/ bb-rep.html.patch
%attr(0644,root,root) %{_sysconfdir}/logrotate.d/bigbrother-larrd
%{BBHOME}/ext/larrd
%{LARRDHOME}/*-larrd.pl
%config %{LARRDHOME}/larrd-config.pl
%{LARRDHOME}/larrd-html.pl
%{LARRDHOME}/larrd_scan.pl
%{LARRDHOME}/larrd.pl
%{CGIBIN}
/usr/local

%changelog
* Sun Dec 11 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 0.43c-4
- Rebuilt in new build system.

* Sun Jun 26 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 0.43c-3
- Added patch to fix vmstat bf on systems with procps 3+.
- Changed Group for larrd-server.

* Sun Mar 27 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org>
- Removed perl-CGI from server Requires: since it seems that RHEL4 has
  it merged into the perl package.
- Added Provides to server section to make rpm happy.
- Fixed preun and post to use correct paths.

* Fri May 21 2004 RazorsEdge Packaging <rpmpackaging@razorsedge.org>
- Modified bf-larrd.sh to use %{BBHOME}/ext instead of /usr/local/larrd.

* Mon Apr 26 2004 RazorsEdge Packaging <rpmpackaging@razorsedge.org>
- First package.

